



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS运行时Runtime浅析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS运行时Runtime浅析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 12:36:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>运行时是iOS中一个很重要的概念，iOS运行过程中都会被转化为runtime的C代码执行。例如[target doSomething];会被转化成objc)msgSend(target,@selector(doSomething))来执行。这篇博客会较为全面的来讲解下Runtime。</p>
<p>OC是一门动态语言，它将很多静态语言在编译和链接时做的事放到了运行时来处理。这种动态语言的优势在于：写代码能更加灵活，可以把消息转发给想要的对象，或者随意交换一个方法的实现。</p>
<p>OC Runtime目前有两个版本：Modern Runtime和Legacy Runtime。Modern Runtime覆盖了64位的App，Legacy Runtime使用早期的32位App，所以现在可以不用管了。</p>
<p>（1）当我们需要使用Runtime的接口时，需要导入头文件：#import &lt;objc/runtime.h&gt;,Runtime可以进行如下操作，在运行时来获取当前类中的一些信息：</p>
<p>获取属性列表：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717111241034?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>获取方法列表：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717111333108?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>获取成员变量列表：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717111428140?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>获取协议列表：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717111515397?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>所以，我们大概可以总结出Runtime的作用：</p>
<ul><li>程序运行中，动态创建一个类；</li>
<li>程序运行中，动态为某个类添加属性/方法，修改属性/方法；</li>
<li>遍历一个类的所有成员变量/属性/方法；</li></ul>
<p>（2）方法调用：</p>
<p>如果用实例对象调用实例方法，会到实例的isa指针指向的对象（也就是类对象，没错，其实类也是一个对象）操作。如果调用的是类方法，就会到类的isa指针指向的对象（元类对象）中操作。查找过程如下：</p>
<ul><li>首先在相应操作的对象中的缓存方法列表中找调用的方法，如果找到，转向相应实现并执行；</li>
<li>如果没有找到，在相应操作的对象中的方法列表中找调用的方法，如果找到，转向相应实现执行；</li>
<li>如果没找到，去父类指针所指向的对象中执行以上步骤；</li>
<li>以此类推，如果一直到根类还没有找到，转向拦截调用；</li>
<li>如果没有重写拦截调用的方法，程序报错；</li></ul>
<p>说明下，重写父类的方法，其实并没有覆盖掉父类的方法，只是在当前类对象中找到这个方法后就不会再去父类中找了。如果想调用已经重写过的方法的父类实现，只需使用super这个编译器标志，它会在运行时跳过在当前类对象中寻找方法的过程。</p>
<p>（3）拦截调用</p>
<p>拦截调用就是在找不到调用的方法程序崩溃之前，有机会通过重写NSObject的四个方法来处理：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717113833224?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>以下两个方法需要转发到其他类处理：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717113935381?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<ul><li>第一个方法是调用一个不存在的类方法的时候，会调用这个方法，默认返回NO，可以加上自己的处理后返回YES；</li>
<li>第二个方法和第一个方法类似，处理的是实例方法；</li>
<li>第三个方法是将你调用的不存在的方法重定向到一个其他声明了这个方法的类，只需要返回一个有这个方法的target；</li>
<li>第四个方法是将你调用的不存在的方法打包成NSInvocation传给你。做完你自己的处理后，调用invokeWithTarget:方法让某个target触发这个方法；</li></ul>
<div>&nbsp;</div>
<div>（4）Runtime的常用之处就是可以在运行时动态添加方法。我们在上面讲到了拦截调用，动态添加方法可以和拦截调用结合起来使用。我们可以根据传递进来的SEL类型的selector动态添加一个方法。这样就算我们调用一个还没定义的方法程序也不会crash了。</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717115351870?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />.</div>
<div>&nbsp;</div>
<div>其中class_addMethod的四个参数分别是：</div>
<div>
<ul><li>Class cls :给哪个类添加方法；</li>
<li>SEL name：方法选择器selector;</li>
<li>IMP imp:方法的实现，C方法的实现可以直接获得。如果是OC方法，可以用+(IMP)instanceMethodForSelector获得方法的实现；</li>
<li>const char *types:方法的签名</li></ul>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（5）关联对象</div>
<div>&nbsp; &nbsp; &nbsp; 现在准备使用一个系统的类，你需要额外添加一个属性。我们可以使用继承。但是只增加一个属性，就去继承一个类，是比较浪费的。这时我们就可以使用Runtime的关联属性。</div>
<div>&nbsp;</div>
<div>&nbsp;先定义一个全局变量，用它的地址作为关联对象的key：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717120110849?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp;</div>
<div>设置关联对象：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717120849001?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717120213225?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>objc_setAssociatedObject的四个参数：</div>
<div>
<ul><li>id object:给谁设置关联对象；</li>
<li>const void *key:关联对象唯一的key，就是上面定义的全局变量；</li>
<li>id value：关联对象；</li>
<li>objc_AssociatedPolicy:关联策略：</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717120650826?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717121024211?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>objc_getAssociatedObject的两个参数：</div>
<div>
<ul><li>id object:获取谁的关联对象；</li>
<li>const void *key:根据这个唯一的key获取关联对象；</li></ul>
</div>
<div>&nbsp;</div>
<div>（6）方法交换</div>
<div>&nbsp; &nbsp; 将两个方法的实现交换。例如，将A方法和B方法交换，调用A方法的时候，就会执行B方法中的代码。反之亦然。我们一般在类的Category中实现以下代码：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717121744573?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（7）Runtime原理与机制</div>
<div>&nbsp; &nbsp; &nbsp;Runtime运行时，就是系统在运行的时候的一些机制，其中最主要的是消息机制。同时Runtime是一套比较底层的C语言API，属于一个C语言库，包含了很多底层的C语言API。程序运行时，最终都是转成了Runtime的C语言代码。</div>
<div>OC实现动态调用：</div>
<div>[obj makeText];</div>
<div>&nbsp;</div>
<div>在编译时Runtime会将代码转化为：</div>
<div>objc_msgSend(obj,@selector(makeText));</div>
<div>&nbsp;</div>
<div>obj对象有一个isa指针，</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717123047249?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>所有metaclass中isa指针都指向根metaclass，而根metaclass则指向自身。Root metaclass是通过继承Root Class产生的，与root class结构体成员一致。</div>
<div>@selector(makeText):这是一个SEL方法选择器。SEL主要作用是快速通过方法名字(makeText)查找到对应方法的函数指针，然后调用函数。SEL本身是一个int类型的地址，地址中存放着方法的名字。对于一个类中，每一个方法对应着一个SEL，所以iOS中不能存在2个名称相同的方法，即使参数类型不同。</div>
<div>&nbsp;</div>
<div>动态查找过程：</div>
<div>&nbsp; &nbsp; &nbsp; 编译器将代码[obj makeText]；转化为objc_msgSend(obj,@selector(makeText));在objc_msgSend函数中，首先通过obj的isa指针找到obj对应的class。在Class中先去cache中通过SEL查找对应函数method，若cache中未找到，再去methodList中查找，若methodList中未找到，则到superClass查找。若能找到，则将method加入到cache中，以方便下次查找，并通过method中的函数指针跳转到对应的函数中去执行。</div>
<div>&nbsp;</div>
<div>注意：上面提到为什么要先去查找缓存cache？</div>
<div>因为当调用了一个方法，很有可能之后还会调用它。软件开发的同学应该都可以理解。</div>
<p>（8）OC中的类</p>
<p>OC类是由Class类型来表示的，实际上是一个指向objc_class结构体的指针，Class定义在objc.h中：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717133915718?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>苹果注释中也说明了，Class是一个隐含类型代表了一个OC类。查看runtime.h中关于objc_class结构体的定义：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717134114235?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>注释中也说明，以后使用Class来替代struct objc_class,这样就可以方便类型定义。</p>
<ul><li>version：类的版本信息，默认为0；</li>
<li>info：类信息，运行时使用的一些位标志；</li>
<li>instance_size:类的实例变量的大小；</li></ul>
<div>其中我们最关心的参数是：</div>
<div>
<ul><li>isa：所有的类自身也是一个对象，这个对象的Class里面也有一个isa指针，它指向metaClass元类；</li>
<li>super_class：指向该类的父类，如果该类已经是最顶层的根类（如NSObject或NSProxy），则super_class为NULL；</li></ul>
<div>&nbsp;</div>
</div>
<div>&nbsp;</div>
<div>（9）类的实例</div>
<div>&nbsp; &nbsp; &nbsp;objc_object表示的是一个类的实例的结构体，在objc.h中定义：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717135001233?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp;</div>
<div>注释中也说明了，objc_object代表了类的实例。然后使用id来指向这个类的实例结构体，同样在objc_h中定义：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717135301112?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp;一个指向实例的指针。可以看到在结构体中只有一个字段，就是指向其类的isa指针。这样，当我们向一个OC对象发送消息时，运行时库会根据实例对象的isa指针找到这个实例对象所属的类。Runtime库会在类的方法列表及父类的方法列表中去寻找与消息对应的selector指向的方法，找到后即运行这个方法。</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp;id:是一个objc_object结构类型的指针，可以转换为任何一种对象，类似C中的void *.</div>
<div>&nbsp;</div>
<p>（10）元类MetaClass</p>
<p>所有的类自身也是一个对象，可以向这个对象发送消息（即调用类方法）。</p>
<p>NSArray *array = [NSArray array];</p>
<p>+array消息发送给了NSArray类，而这个NSArray也是一个对象。既然是对象，那么它也是一个objc_object指针，包含一个指向其类的一个isa指针。为了调用+array方法，这个类的isa指针必须指向一个包含这些类方法的一个objc_class结构体。这就需要meta_class概念。</p>
<p>meta_class是一个类对象的类。当我们向一个对象发送消息时，Runtime会在这个对象所属的这个类的方法列表中查找方法。而向一个类发送消息时，会在这个类的meta_class的方法列表中查找。meta_class很重要，因为它存储着一个类的所有的类方法。每个类都会有一个单独的meta_class，因为每个类的类方法基本不可能完全相同。</p>
<p>再看一下上面提到的图，现在应该有更深的理解：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717141526672?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>所有的meta_class的isa指向基类的meta_class,依次作为他们的所属类。即任何NSObject继承体系下的meta_class都使用NSObject的meta_class作为自己的所属类，而基类的meta_class的isa指针指向自己，这样就形成了闭环。</p>
<p>（11）类与对象操作函数</p>
<p>类的操作方法大部分是以class为前缀的，而对象的操作方法大部分是以objc或object_为前缀的。</p>
<ul><li>类名</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717142451082?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</p>
<p>返回一个类的名字，传入的参数是类对象。</p>
<ul><li>父类(super_class)和元类(meta_class)</li></ul>
<div>获取类的父类：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717142652427?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>判断给定的Class是否是一个元类：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717142748584?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<p>获取实例变量的大小：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717142927991?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>在objc_class中，所有的成员变量，属性的信息是放在链表ivars中的，ivars是一个数组，数组中每个元素是指向Ivar的指针。</p>
<ul><li>获取类中实例成员变量的信息</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717143416234?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取类成员变量的信息</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717143650643?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>添加成员变量</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717143931198?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取成员变量列表</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717144056652?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<p>以下数属性操作函数</p>
<ul><li>获取指定的属性</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717144614060?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取属性列表</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717144746421?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>为类添加属性</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717144847862?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>替换类的属性</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717145025490?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<p>以下为方法操作函数：</p>
<ul><li>添加方法</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717145557299?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取实例方法</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717145718050?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取类方法</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717145812672?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取所有方法的数组</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717145915407?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>替换方法的实现</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717150105894?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回方法的具体实现</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717150301022?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>类实例是否响应指定的selector</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717150419757?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<div>&nbsp;</div>
<p>协议操作函数如下:</p>
<ul><li>添加协议</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717153902697?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回类是否实现指定的协议</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717154425352?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回类实现的协议列表</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717154549602?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<div>&nbsp;</div>
<p>获取版本Version如下：</p>
<ul><li>获取版本号</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717154708067?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>设置版本号</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717154804428?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>（12）动态创建类</p>
<ul><li>创建一个新类和元类</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717155038089?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>销毁一个类及其相关联的类</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717155210136?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>在应用中注册由objc_allocateClassPair创建的类</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717155354652?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>objc_allocateClassPair函数：如果要创建一个根类，则superclass指定为nil，extraBytes通常指定为0,该参数是分配给类和元类对象尾部的索引ivars的字节数。然后使用诸如class_addMethod,class_addIvar等函数来为新创建的类添加方法，实例变量和属性。完成这些后，需要调用objc_registerClassPair函数来注册类，之后这个新类就可以在程序中使用了。</p>
<p>注意：实例方法和实例变量应该添加到类自身上，类方法应该添加到类的元类上。</p>
<p>（13）动态创建对象</p>
<ul><li>创建类实例</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717160330563?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>在指定位置创建类实例</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717160505971?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>销毁类实例</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717160604421?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>（14）实例操作函数</p>
<p>实例操作函数主要是针对我们创建的实例对象的一系列操作函数，我们可以使用这组函数来从实例对象中获取我们要的信息，如实例对象中变量的值。</p>
<ul><li>返回指定对象的一份拷贝</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717161056380?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>释放指定对象占用的内存</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717161205069?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>----------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<p>针对对象实例变量进行操作的函数</p>
<ul><li>修改类实例的实例变量的值</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717161614184?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<ul><li>获取类对象中实例变量</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717164021198?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回对象中实例变量的值</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717164302687?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>设置对象中实例变量的值</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717164414813?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>----------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<div>&nbsp;</div>
<p>针对对象的类进行操作的函数</p>
<ul><li>返回给定对象的类名</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717164715020?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回对象的类</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717164813773?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>设置对象的类</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717165018854?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<p>----------------------------------------------------------------------------------------------------------------------------------------------------------------------------</p>
<div>&nbsp;</div>
<p>获取类定义：Runtime会自动注册我们代码中定义的所有类，我们也可以在运行时创建类定义并使用objc_addClass函数来注册他它们。</p></div>
<div>&nbsp;</div>
<div>
<ul><li>获取已注册的类定义的列表</li></ul>
</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717165853164?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>创建并返回一个指向所有已注册类的指针列表</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717170103791?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>返回指定类的类定义</li></ul>
</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717170204277?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717170252121?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717170331451?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>返回指定类的元类</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717170445903?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>（15）成员变量、属性</p>
<ul><li>Ivar</li></ul>
<div>Ivar是表示实例变量的类型，实际是一个指向objc_ivar结构体的指针。</div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717171310875?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717171424246?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>objc_property_t</li></ul>
<div>objc_property_t是表示OC声明的属性的类型，实际是指向objc_property结构体的指针。</div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717171750502?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>objc_property_attribute_t</li></ul>
<div>定义了属性的特性，是一个结构体。</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717172113567?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（16）关联对象</div>
<div>&nbsp; &nbsp; &nbsp; 关联对象类似于成员变量，不过是在运行时添加的。通常会把成员变量Ivar放在类声明的头文件中，或者放在类实现的@implementation后面。但是有一个缺点，不能在Category中添加成员变量，否则会编译器报错。可以把关联对象想象成一个OC对象（如字典），这个对象通过给定的key连接到类的一个实例上。由于使用的是C接口，所以key是一个void指针(const void *). 其中使用以下的内存管理策略来管理这个对象。同上面（5）</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717183432832?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（17）SEL</div>
<div>&nbsp; &nbsp; SEL叫选择器，是表示一个方法的selector指针，定义如下：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717184015038?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>objc_selector结构体的详细定义没有在头文件中找到，方法的selector用于表示运行时方法的名字。OC在编译时，会根据每一个方法的名字生成一个唯一的整型标志（int类型的地址），这个标示就是SEL。</div>
<div>代码所示：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717184348681?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>打印结果如下：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717184507853?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp; &nbsp; &nbsp;两个类之间，如果是继承关系，只要方法名相同，那么方法的SEL就是一样的。每一个方法对应一个SEL。所以在OC的同一个类中（或类的继承体系中），不能存在两个同名的方法，即使参数类型不同也不行。所以说，OC不存在重载的概念。当然，不同的类可以拥有相同的selector。不同类的实例对象执行相同的selector时，会在各自的方法列表中去根据selector寻找自己对应的IMP。</div>
<div>&nbsp; &nbsp; &nbsp;工程中所有的SEL组成了一个Set集合，Set的特点就是唯一，因此SEL是唯一的。因此，如果我们想到这个方法集合中查找某个方法时，只需要找到这个方法对应的SEL即可。SEL实际上就是根据方法名hash了一个字符串，而对于字符串的比较仅仅需要比较他们的地址就可以了。本质上，SEL只是一个指向方法的指针。</div>
<div>&nbsp;&nbsp;</div>
<div>&nbsp;</div>
<div>（18）IMP</div>
<div>&nbsp; &nbsp; &nbsp;IMP实际上是一个函数指针，指向方法实现的首地址。定义如下：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717190141516?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>第一个参数是指向self的指针（如果是实例方法，则是类实例的内存地址；如果是类方法，则是指向元类的指针），第二个参数是方法选择器（selector），接下来是方法的实际参数列表。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（19）Method</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717191153703?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717191218130?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>看到在结构体中有SEL和IMP，相当于在SEL和IMP之间做了一个映射。有了SEL，就可以找到对应的IMP，从而调用方法的实现代码。</div>
<div>&nbsp;</div>
<div>objc_method_description定义了一个OC方法，定义如下：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717191552427?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（20）方法相关操作函数</div>
<div>
<ul><li>调用指定方法的实现</li></ul>
</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717191849414?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717191918321?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>获取方法名</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717192119199?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<ul><li>返回方法的实现</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717192211403?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>获取描述方法参数和返回值类型的字符串</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717192416609?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<ul><li>获取方法指定位置参数的类型字符串</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717192742481?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<ul><li>通过引用返回方法的返回值类型字符串</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717192931169?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<ul><li>返回方法的参数个数</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717193055107?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp;</div>
<div>
<ul><li>返回指定方法的方法描述结构体</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717193609640?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>设置方法的实现</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717193708328?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>交换两个方法的实现</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717193825441?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（21）方法选择器</div>
<div>
<ul><li>返回给定选择器指定的方法的名称</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717195904057?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>Runtime中注册一个方法，将方法名映射到一个选择器，并返回这个选择器。在我们将一个方法添加到类定义时，必须在Runtime中注册一个方法名以获取方法的选择器。</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717200207239?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>
<ul><li>在Runtime中注册一个方法</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717200408247?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>
<ul><li>比较两个选择器</li></ul>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717200500041?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（22）方法调用流程</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp;在OC中，消息直到运行时才绑定到方法的实现上。编译器会将消息表达式[receive message]转化为一个消息函数的调用，即objc_msgSend。这个函数将消息接收者和方法名作为基础参数，如下所示：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717202148516?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>可以看到，第三个参数是个可变参数，用来传递原方法的参数列表：</div>
<div>objc_msg_Send(receive,selector,arg1,arg2).这个函数完成了动态绑定的所有事情。</div>
<div>
<ul><li>首先它找到selector对应的方法实现。因为同一个方法可能在不同的类中有不同的实现，所以我们需要依赖接收者的类来找到确切的实现。</li>
<li>它调用方法的实现，并将接收者对象及方法的所有参数传给它。</li>
<li>最后，它将实现的返回值作为他自己的返回值。</li></ul>
<div>消息的关键在于objc_class,有两个字段是我们在分发消息时关注的：</div>
</div>
<div>-- 指向父类的指针；</div>
<div>-- 一个类的方法的分发表，即methodList;</div>
<div>&nbsp;</div>
<div>消息的基本框架：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717203453025?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" />。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>（23）消息转发</div>
<div>&nbsp; &nbsp; &nbsp;当一个对象能接收一个消息时，就会走正常的方法调用流程。默认情况下，如果是以[object message]的方式调用方法，如果object无法响应message消息时，编译器会报错。但如果是以perform...的形式来调用，则需要等到运行时才能确定object是否能接收message消息。如果不能，则程序崩溃。通常，当我们不能确定一个对象是否能接收某个消息时，会先调用respondsToSelector:来判断一下：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717204826736?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>----------------------------------------------------------------------------------------------------------------------------------------------</div>
<div>&nbsp;</div>
<div>当一个对象无法接收某一消息时，就会使用&rdquo;消息转发(message forwarding)&ldquo;机制。通过这一机制，我们可以告诉对象如何处理未知的消息。消息转发分为三个步骤：</div>
<div>
<ul><li>动态方法解析；</li>
<li>备用接收者；</li>
<li>完整转发；</li></ul>
<div>&nbsp;</div>
</div>
<div>--- 动态方法解析</div>
<div>对象在接收到未知的消息时，首先会调用所属类的类方法+resolveInstanceMethod:实例方法或者+resolveClassMethod:类方法。在这个方法中，我们有机会为该未知消息新增一个处理方法，不过使用该方法的前提是我们已经实现了该处理方法，只需要在运行时通过class_addMethod函数动态添加到类里面就行了。如下代码所示：</div>
<div>
<div>
<ol><li>void&nbsp;functionForMethod1(id&nbsp;self,&nbsp;SEL&nbsp;_cmd)&nbsp;{</li>
<li>NSLog(@"%@,&nbsp;%p",&nbsp;self,&nbsp;_cmd);</li>
<li>}</li>
<li>+&nbsp;(BOOL)resolveInstanceMethod:(SEL)sel&nbsp;{</li>
<li>NSString&nbsp;*selectorString&nbsp;=&nbsp;NSStringFromSelector(sel);</li>
<li>if&nbsp;([selectorString&nbsp;isEqualToString:@"method1"])&nbsp;{</li>
<li>class_addMethod(self.class,&nbsp;@selector(method1),&nbsp;(IMP)functionForMethod1,&nbsp;"@:");</li>
<li>}</li>
<li>return&nbsp;[super&nbsp;resolveInstanceMethod:sel];</li>
<li>}</li></ol>
</div>
</div>
<div>---备用接收者</div>
<div>&nbsp; &nbsp; &nbsp;如果上一步无法处理消息，则Runtime会继续调用以下方法：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717211545059?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>如果一个对象实现了这个方法，并返回一个非nil的结果，则这个对象会作为消息的新接收者，且消息会被分发到这个对象。当然这个对象不能是self自身，否则会出现无线循环。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>--- 完整消息转发</div>
<div>如果在上一步还不能处理未知消息，则唯一能做的就是启用完整的消息转发机制了，此时会调用以下方法：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717212948734?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>运行时系统会在这一步给消息接收者最后一次机会将消息转发给其他对象。对象会创建一个表示消息的NSInvocation对象，把与尚未处理的消息有关的全部细节都封装在NSInvocation中，包括selector，target和参数。我们可以在forwardInvocation方法中将消息转发给其他对象。</div>
<div>同时我们必须重写以下方法：</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20160717213501960?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></div>
<div>&nbsp;</div>
<div>&nbsp;Runtime博大精深，以上只是对Runtime的概念、原理和接口方法讲解</div>
<div>&nbsp;</div>
<div>链接：</div>
<div><a href="http://blog.csdn.net/chenyufeng1991/article/details/51931320" rel="external nofollow noreferrer">iOS运行时Runtime浅析</a></div>
<div><a href="http://blog.csdn.net/column/details/chenyufeng-ios.html" rel="external nofollow noreferrer">iOS开发技术分享</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy1xrdq.html">CozyRSS1&period;0 - 有可用性版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxro1vq.html">3&period;聚类&amp;ndash&semi;K-means的Java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0l41q.html">spring security为不同用户显示各自的登录成功页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93zwdwq.html">C语言实现二叉树-03版</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gy6n8.html">IOS 7 UI 的适配</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwlmx8.html">我的常用mixin 之 px</a>
		</li>
						<li><a href="https://www.batexi.com/a/390w674q.html">Java框架基础&mdash;&mdash;反射&lpar;reflect&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn63oq.html">PHP 高并发、抢票、秒杀 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vekxo8.html">Sharepoint中有关文件夹的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwjgx8.html">nginx&plus;memcached&plus;ftp上传图片&plus;iis</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yl47n8.html">POJ1741</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpkne8.html">Spring Boot 最核心的 25 个注解，都是干货！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7jy38.html">Saiku嵌入系统使用时传参数访问saiku&lpar;十六&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16r1oq.html">Java开发知识之Java字符串类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oev5j8.html">centos7下安装docker（17&period;3docker监控---cAdvisor）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll4njxq.html">Qt 查询字符串数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2x6l8.html">20155208实验三 敏捷开发与XP实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvwxegq.html">Partition2：对现有表分区</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emmy0x9.html">js获取系统的根路径实现介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlyj6q.html">mouseenter 事件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q265px9.html">Iconfont-阿里巴巴矢量图标库</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxj008.html">入CTF坑必不可少的地方-保持更新</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26x6l9.html">磁带机Media is unrecognized</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pvmoy9.html">C&num;语句1：选择语句二（switch  break）</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rwyp7q.html">&period;NET领域驱动设计&mdash;看DDD是如何运用设计模式颠覆传统架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7jlyeq.html">web会话管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/r936dmn9.html">（企业面试部分）超详细思路讲解SQL语句的查询实现，及数据的创建。</a>
			</li>
						<li><a href="https://www.batexi.com/a/r936d0g9.html">javascript 基础教程&lbrack;温故而知新一&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyo5dg8.html">sqlyog不用密码登陆（强制取消）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q262rw9.html">Centos 7 ASP&period;NET Core 1&period;0 Docker部署</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
